/**
   Chip Level runtime support.
*/

#include "include/cl.h"
#include "include/cl_regs.h"

void 
cl_kick_unlock()
{
  /* See TMS320C6678 datasheet, section 3.3.4 */
  cl_registers->kick[0] = 0x83e70b13ul;
  cl_registers->kick[1] = 0x95a4f1e0ul;
}

void 
cl_kick_lock()
{
  cl_registers->kick[0] = 0x0ul;
  cl_registers->kick[1] = 0x0ul;
}

uint64_t 
cl_get_mac_address()
{
  uint64_t mac_address;

  mac_address = cl_registers->mac_id[0];
  mac_address |= ((uint64_t)(cl_registers->mac_id[1] & 0xffff)) << 32;

  return mac_address;
}
