/**
   Chip-Level Register definitions.
*/

#ifndef RT_CL_REGS_H
#define RT_CL_REGS_H

#include <stdint.h>

/**
   Chip-level HyperLink SerDes configuration.
*/
struct cl_hl_serdes_config
{
  uint32_t rx_config;
  uint32_t tx_config;
};

/**
   Chip-level register definition.
*/
struct cl_registers 
{
  uint32_t res1[14];		                  /* 0x000 - 0x034 */
  uint32_t kick[2];				  /* 0x038 - 0x03c */
  uint32_t dsp_boot_addr[8];			  /* 0x040 - 0x05c */
  uint32_t res2[32];				  /* 0x060 - 0x0df */
  uint32_t res3[12];				  /* 0x0e0 - 0x10f */
  uint32_t mac_id[2];				  /* 0x110 - 0x117 */
  uint32_t res4[18];				  /* 0x118 - 0x160 */
  uint32_t hl_serdes_status;			  /* 0x160 */
  uint32_t res5[148];				  /* 0x164 - 0x3b0 */
  uint32_t hl_serdes_pll_config;		  /* 0x3b4 */
  struct cl_hl_serdes_config hl_serdes_config[4]; /* 0x3b8 - 0x3d4 */
  uint32_t res6[266];				  /* 0x3d8 - 0x7fc */
};

static volatile struct cl_registers * const cl_registers = 
  (struct cl_registers *)0x02620000ul;

#endif
