/**
   Semaphore2 registers.
*/

/*

Copyright (c) 2012 Kungliga Tekniska Högskolan 
(Royal Institute of Technology, Stockholm, Sweden).
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

*/

#ifndef RT_SEM_REGS_H
#define RT_SEM_REGS_H

#include <stdint.h>

struct sem_registers {
  uint32_t pid;			/* 0x0000 */
  uint32_t res1;		/* 0x0004 */
  uint32_t rst_run;		/* 0x0008 */
  uint32_t eoi;			/* 0x000c */
  uint32_t res2[60];		/* 0x0010 - 0x00ff */
  uint32_t direct[64];		/* 0x0100 - 0x01ff */
  uint32_t indirect[64];	/* 0x0200 - 0x02ff */
  uint32_t query[64];		/* 0x0300 - 0x03ff */
  uint32_t res3[64];		/* 0x0400 - 0x04ff */
  uint32_t err;			/* 0x0500 */
  uint32_t err_clear;		/* 0x0504 */
  uint32_t err_set;		/* 0x0508 */
  uint32_t res4[189];		/* 0x050c - 0x07ff */
};

static volatile struct sem_registers * const sem_registers =
  (struct sem_registers *)(0x02640000ul);

#endif
