/*

Copyright (c) 2012 Kungliga Tekniska Högskolan 
(Royal Institute of Technology, Stockholm, Sweden).
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

*/

#ifndef UART_REGS_H
#define UART_REGS_H

#include <stdint.h>

/*
  UART Register map.
*/
typedef struct {
  volatile uint32_t rbr_thr;	 /* 00h */
  volatile uint32_t ier;	 /* 04h */
  volatile uint32_t iir_fcr;	 /* 08h */
  volatile uint32_t lcr;	 /* 0ch */
  volatile uint32_t mcr;	 /* 10h */
  volatile uint32_t lsr;	 /* 14h */
  volatile uint32_t msr;	 /* 18h */
  volatile uint32_t scr;	 /* 1Ch */
  volatile uint32_t dll;	 /* 20h */
  volatile uint32_t dlh;	 /* 24h */
  volatile uint32_t revid1;	 /* 28h */
  volatile uint32_t revid2;	 /* 2ch */
  volatile uint32_t pwremu_mgmt; /* 30h */
  volatile uint32_t mdr;	 /* 34h */
} uart_registers_t;

/*
  UART Register location in C6678 devices.
*/
uart_registers_t * const uart_registers=
  (uart_registers_t *)(0x02540000);

#endif
