
;; Copyright (c) 2012 Kungliga Tekniska Högskolan 
;; (Royal Institute of Technology, Stockholm, Sweden).
;; All rights reserved.
;;
;; Redistribution and use in source and binary forms, with or without
;; modification, are permitted provided that the following conditions
;; are met:
;;
;; 1. Redistributions of source code must retain the above copyright
;;    notice, this list of conditions and the following disclaimer.
;;
;; 2. Redistributions in binary form must reproduce the above copyright
;;    notice, this list of conditions and the following disclaimer in the
;;    documentation and/or other materials provided with the distribution.
;;
;; THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
;; ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;; ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
;; FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;; OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;; HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;; LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;; OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;; SUCH DAMAGE.



	;; Simple multi-core startup for C environment
	;; Handles stack in shared address space

	.global __TI_STACK_END
	.global __TI_STACK_SIZE
	.global __TI_STATIC_BASE
	.global _stack
	.global exit
	.global _args_main
	.global _auto_init_elf
	.global __startup
	.global platform_init
	.global platform_exit
	
	.text

__startup:	
	;; First figure out where the stack should start
	mvkl	_stack, b15
	mvkh	_stack, b15

	;; If it is below the magic limit, then we are in shared space
	mvkl	0x01800000, b0
	mvkh	0x01800000, b0

	cmpgtu	b15, b0, b0
 [!b0]	bnop	private_address, 5

shared_address:
	mvkl	__TI_STACK_SIZE, b0
	mvkh	__TI_STACK_SIZE, b0

	shru	b0, 3, b0	; Divide by 8
	mvc	DNUM, b1
	addk	1, b1	
	mpyi	b0, b1, b0	; Multiply by core number to get offset
	nop	8

	add	b0, b15, b15
	add	-4, b15, b15
	and	~15, b15, b15

	bnop	common_init, 5

private_address:
	mvkl	__TI_STACK_SIZE, b0
	mvkh	__TI_STACK_SIZE, b0
	add	b0, b15, b15
	add	-4, b15, b15
	and	~15, b15, b15
	
common_init:

	mvkl	__TI_STATIC_BASE, b14
	mvkh	__TI_STATIC_BASE, b14

	mvkl	auto_init_ret, b3
	mvkh	auto_init_ret, b3

	mvkl	_auto_init_elf, b0
	mvkh	_auto_init_elf, b0
	
	bnop	b0, 5

auto_init_ret:

	mvkl	platform_init_ret, b3
	mvkh	platform_init_ret, b3
	
	mvkl	platform_init, b0
	mvkh	platform_init, b0
	
	bnop	b0, 5
	
platform_init_ret:	

	mvkl	exit_done, b3
	mvkh	exit_done, b3

	bnop	_args_main, 5
	
exit_done:

	mvk	1, a4

	mvkl	platform_exit, b0
	mvkh	platform_exit, b0
	
	bnop	b0, 5
